package com.blamejared.compat.betterwithmods.base.blockrecipes;

import com.blamejared.compat.betterwithmods.base.RemoveAll;
import betterwithmods.common.registry.block.recipe.BlockDropIngredient;
import com.blamejared.mtlib.helpers.InputHelper;
import crafttweaker.api.minecraft.CraftTweakerMC;
import crafttweaker.api.item.IIngredient;
import crafttweaker.api.item.IItemStack;
import stanhebben.zenscript.annotations.ZenMethod;
import com.blamejared.ModTweaker;
import betterwithmods.common.registry.block.managers.CraftingManagerBlock;
import java.util.function.Supplier;
import net.minecraft.item.ItemStack;
import java.util.List;
import betterwithmods.common.registry.block.recipe.BlockIngredient;
import betterwithmods.common.registry.block.recipe.BlockRecipe;

public abstract class BlockRecipeBuilder<T extends BlockRecipe>
{
    protected BlockIngredient input;
    protected List<ItemStack> outputs;
    private Supplier<CraftingManagerBlock<T>> registry;
    protected String name;
    
    public BlockRecipeBuilder(final Supplier<CraftingManagerBlock<T>> registry, final String name) {
        this.registry = registry;
        this.name = name;
    }
    
    protected void addRecipe(final T recipe) {
        ModTweaker.LATE_ADDITIONS.add(new BlockRecipeAdd(this.name, (betterwithmods.common.registry.block.managers.CraftingManagerBlock<BlockRecipe>)this.registry.get(), recipe));
    }
    
    @ZenMethod
    public abstract void build();
    
    public void removeRecipe(final IItemStack[] output) {
        ModTweaker.LATE_REMOVALS.add(new BlockRecipeRemove(this.name, (betterwithmods.common.registry.block.managers.CraftingManagerBlock<BlockRecipe>)this.registry.get(), output));
    }
    
    public void removeRecipe(final IItemStack input) {
        ModTweaker.LATE_REMOVALS.add(new BlockRecipeRemoveInput(this.name, (betterwithmods.common.registry.block.managers.CraftingManagerBlock<BlockRecipe>)this.registry.get(), input));
    }
    
    public void _buildRecipe(final IIngredient input, final IItemStack[] outputs) {
        this.input = new BlockIngredient(CraftTweakerMC.getIngredient(input));
        this.outputs = (List<ItemStack>)InputHelper.toNonNullList((Object[])CraftTweakerMC.getItemStacks(outputs));
    }
    
    @ZenMethod
    public BlockRecipeBuilder setInputBlockDrop(final IItemStack input) {
        this.input = (BlockIngredient)new BlockDropIngredient(new ItemStack[] { CraftTweakerMC.getItemStack(input) });
        return this;
    }
    
    @ZenMethod
    public BlockRecipeBuilder setInputBlockDrop(final IItemStack[] inputs) {
        this.input = (BlockIngredient)new BlockDropIngredient(CraftTweakerMC.getItemStacks(inputs));
        return this;
    }
    
    @ZenMethod
    public void removeAll() {
        ModTweaker.LATE_REMOVALS.add(new RemoveAll(this.name, this.registry.get().getRecipes()));
    }
    
    public String getName() {
        return this.name;
    }
}
